# Backlog.pl
# Backs up the Event logs with an auto incremental name,
# clears the Event logs and writes an event record to the
# application Event log

require "NT.ph";

# If the argument is left blank use the current directory
if ($ARGV[0] eq "") {
     $ARGV[0] = ".";
}

# If the directory does not exists ask to create it
if (!-d $ARGV[0]) {
    print "$ARGV[0] does not exist create? [y/n] : ";
    if (<STDIN> =~ /^y/i) {
    qx(mkdir $ARGV[0])
    } else {
        die "No backups carried out\n";
    }
}

# Set the log names and get the date
@eventlogs = ("system","security","application");
($sec,$min,$hour,$day,$month,$year) = localtime(time);
$month++;

# Fire each log, loop around using the day,month and a letter to
# create a unique name for the backup file
foreach $log(@eventlogs) {
    $log =~/(\w{3})/;
    $backlog = $ARGV[0]."\\".$1.$day."_".$month."a";

# If the backup file exists, increment the end letter and try again    
    while (-e $backlog) {
        $replace = chop($backlog);
        $backlog = $backlog.++$replace
    }

# Open the event log 
    Win32::OpenEventLog($logopen,$ENV{COMPUTERNAME},$log);

# Make a backup and then clear the log    
    if (Win32::ClearEventLog($logopen,$backlog)) {
        print "$log backed up to - $backlog\n"
    } else {
        Win32::WriteEventLog($ENV{COMPUTERNAME}, "BackLog",&EVENTLOG_ERROR_TYPE,&NULL,517,&NULL,&NULL,"BACKLOG - backup FAILED","","",$ENV{USERNAME},$ENV{USERDOMAIN},"");
        die "BACKLOG FAILED TO CREATE BACKUPS\n";
    }

# Close the log
    Win32::CloseEventLog($logopen);

}# End of FOREACH

# Write a record to the application event log to indicate a successful 
# backup has been done
Win32::WriteEventLog($ENV{COMPUTERNAME},"BackLog",&EVENTLOG_INFORMATION_TYPE,&NULL,517,&NULL,&NULL,"BACKLOG - backup completed","","",$ENV{USERNAME},$ENV{USERDOMAIN},"");
