# eventlog.pl
# This script is for altering the crash on fail, maximum size, and retention
# settings. 
require "NT.ph";

sub SetCrashValue {
    $setting = shift @_;
    print "Setting CrashOnAuditFail value to $setting";
    Win32::RegOpenKeyEx(&HKEY_LOCAL_MACHINE, 'SYSTEM\CurrentControlSet\Control\Lsa',
        &NULL, &KEY_ALL_ACCESS, $hkey) ?  print '.' :
        die "Unable to open Crash Control Key\n";

    Win32::RegSetValueEx($hkey,'CrashOnAuditFail', &NULL, &REG_DWORD, $setting) ?
        print '.' : die "Unable to set value\n";
    
    Win32::RegCloseKey($hkey);
    print " Done.\n";
}

sub SetLog {
    $log = shift @_;
    $value = shift @_;
    $setting = shift @_;
    print "Setting $log $value to $setting";
    Win32::RegOpenKeyEx(&HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Services\\EventLog\\$log",
        &NULL, &KEY_ALL_ACCESS, $hkey) ?  print '.' :
        die "Unable to open $log Key\n";
    Win32::RegSetValueEx($hkey,$value, &NULL, &REG_DWORD, $setting) ?
        print '.' : die "Unable to set $value\n";
    
    Win32::RegCloseKey($hkey);
    print " Done.\n";
}
sub DisplayLogInfo {
    Win32::RegOpenKeyEx(&HKEY_LOCAL_MACHINE, 'SYSTEM\CurrentControlSet\Control\Lsa',
        &NULL, &KEY_ALL_ACCESS, $hkey) or print "Unable to open Crash Control Key\n";
    Win32::RegQueryValueEx($hkey, 'CrashOnAuditFail',&NULL, $type, $crash) ?
        print "CrashOnAuditFail set to: ",ord($crash),"\n" :
        print "CrashOnAuditFail read failure - value may not exist\n";
    Win32::RegCloseKey($hkey);
    if($log = shift @_) {
        
        Win32::RegOpenKeyEx(&HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Services\\EventLog\\$log",
            &NULL, &KEY_ALL_ACCESS, $hkey) or print "Unable to open $log Key\n";
        Win32::RegQueryValueEx($hkey, 'File',&NULL, $type, $path) ?
            print "Path set to: ",$path,"\n" :
            print "Path read failure - value may not exist\n";
        Win32::RegQueryValueEx($hkey, 'MaxSize',&NULL, $type, $size) ?
            print "MaxSize set to: ",unpack("L",$size)/1024," KB\n" :
            print "MaxSize read failure - value may not exist\n";
        Win32::RegQueryValueEx($hkey, 'Retention',&NULL, $type, $sec) ?
            print "Retention set to: ",unpack("L",$sec)/3600," HRS\n" :
            print "Retention read failure - value may not exist\n";

        Win32::RegCloseKey($hkey);  
    }

}


while ($command = shift @ARGV) {
    if($command eq '/c') {
        $command = shift @ARGV;
        if($command eq 'on' or $command eq 'reset') {
            SetCrashValue(1);
            next;
        } else {
            SetCrashValue(0);
            next;
        }
    } elsif ($command eq '/s') {
        $command = shift @ARGV;
        SetLog($log,'MaxSize',$command*1024);
        next;
    } elsif ($command eq '/r') {
        $command = shift @ARGV;
        SetLog($log, 'Retention', $command*3600);
        next;
    } elsif ($command eq '/f') {
        $command = shift @ARGV;
        SetLog($log, 'File', $command);
    } else {
        $log = $command;
    }
}

DisplayLogInfo($log);





